diff --git a/src/main/java/net/minecraft/core/world/chunk/LightUpdate.java b/src/main/java/net/minecraft/core/world/chunk/LightUpdate.java
index 46403e045..771747964 100644
--- a/src/main/java/net/minecraft/core/world/chunk/LightUpdate.java
+++ b/src/main/java/net/minecraft/core/world/chunk/LightUpdate.java
@@ -3,13 +3,23 @@ package net.minecraft.core.world.chunk;
 // Referenced classes of package net.minecraft.src:
 //            World, Chunk, Block, EnumSkyBlock
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
+import org.slf4j.Logger;
 
 public class LightUpdate
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    public final LightLayer layer;
+    public int minX;
+    public int minY;
+    public int minZ;
+    public int maxX;
+    public int maxY;
+    public int maxZ;
+
 
     public LightUpdate(LightLayer layer, int minX, int minY, int minZ, int maxX, int maxY, int maxZ)
     {
@@ -31,7 +41,7 @@ public class LightUpdate
         int area = sizeX * sizeY * sizeZ;
         if(area > Chunk.CHUNK_SIZE_X * Chunk.CHUNK_SIZE_Z * world.getHeightBlocks())
         {
-            System.out.println("Light too large, skipping!");
+            LOGGER.warn("Light too large, skipping!");
             return;
         }
 
@@ -230,12 +240,4 @@ public class LightUpdate
         }
         return false;
     }
-
-    public final LightLayer layer;
-    public int minX;
-    public int minY;
-    public int minZ;
-    public int maxX;
-    public int maxY;
-    public int maxZ;
 }
diff --git a/src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java b/src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java
index c45e05b97..ec93f9182 100644
--- a/src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java
+++ b/src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java
@@ -4,11 +4,14 @@ package net.minecraft.core.world.chunk;
 // Referenced classes of package net.minecraft.src:
 //            Block
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.Blocks;
+import org.slf4j.Logger;
 
 public class MissingBlockFixer
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    private static final short[] blocksArray;
 
     public MissingBlockFixer()
     {
@@ -22,8 +25,6 @@ public class MissingBlockFixer
         }
     }
 
-    private static final short[] blocksArray;
-
     static 
     {
         blocksArray = new short[Block.blocksList.length];
@@ -41,7 +42,7 @@ public class MissingBlockFixer
         }
         catch (Exception exception)
         {
-            exception.printStackTrace();
+            LOGGER.error("Exception initializing blocksArray!", exception);
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java b/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java
index f143486cb..85fe76d42 100644
--- a/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java
+++ b/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java
@@ -3,6 +3,8 @@ package net.minecraft.core.world.data;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.io.*;
 import java.util.*;
@@ -21,14 +23,18 @@ public class SynchedEntityData
     public static final int TYPE_STRING = 4;
     public static final int TYPE_ITEMSTACK = 5;
     public static final int TYPE_CHUNK_COORDINATE = 6;
+    public static final int TYPE_UUID = 7;
 
     // Format Constants
     public static final int MAX_DATA_VALUE = 31;
     public static final int TYPE_MASK = 0b1110_0000;
     public static final int TYPE_SHIFT = 5;
+
+    public static final int META_NULL = 0b0000_0001;
+
     public static final int END_MARKER = 127;
     private static final HashMap<Class<?>, Integer> DATA_TYPES = new HashMap<>();
-    private final Map<Integer, DataItem<?>> itemsById = new HashMap<>();
+    private final Map<Integer, @NotNull DataItem<?>> itemsById = new HashMap<>();
     private boolean isDirty;
 
     /**
@@ -61,6 +67,36 @@ public class SynchedEntityData
         }
     }
 
+    /**
+     * Attempts to define a new piece of synchronized data.
+     * @param id The ID of the data item.
+     * @param valueClass The class to define for the data item, which will default the initial value to null.
+     * @param <T> The type of the data item.
+     */
+    public <T> void define(int id, Class<T> valueClass)
+    {
+        Integer integer = DATA_TYPES.get(valueClass);
+        if(integer == null)
+        {
+            throw new IllegalArgumentException("Unknown data type: " + valueClass);
+        }
+
+        if(id > MAX_DATA_VALUE)
+        {
+            throw new IllegalArgumentException("Data value id is too big with " + id + "! (Max is " + MAX_DATA_VALUE + ")");
+        }
+
+        if(itemsById.containsKey(id))
+        {
+            throw new IllegalArgumentException("Duplicate id value for " + id + "!");
+        }
+        else
+        {
+            DataItem<T> item = new DataItem<>(integer, id, null);
+            itemsById.put(id, item);
+        }
+    }
+
     /**
      * Fetches the value for a specific item as a byte.
      * @param id The item ID.
@@ -106,16 +142,29 @@ public class SynchedEntityData
         return (ItemStack) itemsById.get(id).getValue();
     }
 
+    /**
+     * Fetches the value for a specific item as a UUID.
+     * @param id The item ID.
+     */
+    public UUID getUUID(int id) {
+        return (UUID) itemsById.get(id).getValue();
+    }
     /**
      * Sets the value for a defined item.
      * @param id The item ID.
      * @param value The value to assign to the item.
      * @param <T> The type of the data item.
      */
-    public <T> void set(int id, T value)
+    public <T> void set(int id, @Nullable T value)
     {
         DataItem<T> item = (DataItem<T>)itemsById.get(id);
-        if(!value.equals(item.getValue()))
+        if (value == null && item.getValue() != null) {
+            item.setValue(null);
+            item.setDirty(true);
+            isDirty = true;
+            return;
+        }
+        if(value != null && !value.equals(item.getValue()))
         {
             item.setValue(value);
             item.setDirty(true);
@@ -204,39 +253,56 @@ public class SynchedEntityData
         int typeValueByte = (di.getType() << TYPE_SHIFT | di.getId() & ~TYPE_MASK) & 0xFF;
         dos.writeByte(typeValueByte);
 
+        byte metadata = 0;
+        T value = di.getValue();
+        if (value == null) {
+            metadata |= META_NULL;
+            dos.writeByte(metadata);
+            return;
+        }
+
         switch(di.getType()) {
             case TYPE_BYTE:
-                dos.writeByte((Byte) di.getValue());
+                dos.write(metadata);
+                dos.writeByte((Byte) value);
                 break;
             case TYPE_SHORT:
-                dos.writeShort((Short) di.getValue());
+                dos.write(metadata);
+                dos.writeShort((Short) value);
                 break;
             case TYPE_INT:
-                dos.writeInt((Integer) di.getValue());
+                dos.write(metadata);
+                dos.writeInt((Integer) value);
                 break;
             case TYPE_FLOAT:
-                dos.writeFloat((Float) di.getValue());
+                dos.write(metadata);
+                dos.writeFloat((Float) value);
                 break;
             case TYPE_STRING:
-                Packet.writeString((String)di.getValue(), dos);
+                String s = (String)value;
+                dos.write(metadata);
+                Packet.writeString(s, dos);
                 break;
             case TYPE_ITEMSTACK:
-                ItemStack itemStack = (ItemStack)di.getValue();
-                if (itemStack == ItemStack.NO_ITEM){
-                    dos.writeShort(-1);
-                    dos.writeByte(-1);
-                    dos.writeShort(-1);
-                } else {
-                    dos.writeShort(itemStack.getItem().id);
-                    dos.writeByte(itemStack.stackSize);
-                    dos.writeShort(itemStack.getMetadata());
-                }
+                ItemStack itemStack = (ItemStack)value;
+                dos.write(metadata);
+                dos.writeShort(itemStack.getItem().id);
+                dos.writeByte(itemStack.stackSize);
+                dos.writeShort(itemStack.getMetadata());
                 break;
             case TYPE_CHUNK_COORDINATE:
-                ChunkCoordinates chunkcoordinates = (ChunkCoordinates)di.getValue();
+                ChunkCoordinates chunkcoordinates = (ChunkCoordinates)value;
+                dos.write(metadata);
                 dos.writeInt(chunkcoordinates.x);
                 dos.writeInt(chunkcoordinates.y);
                 dos.writeInt(chunkcoordinates.z);
+
+                break;
+            case TYPE_UUID:
+                UUID uuid = (UUID) value;
+                dos.write(metadata);
+                dos.writeLong(uuid.getMostSignificantBits());
+                dos.writeLong(uuid.getLeastSignificantBits());
                 break;
         }
     }
@@ -260,40 +326,45 @@ public class SynchedEntityData
             }
             int type = (data & TYPE_MASK) >> TYPE_SHIFT;
             int id = data & ~TYPE_MASK;
-            DataItem<?> di = null;
-            switch(type)
-            {
-                case TYPE_BYTE:
-                    di = new DataItem<>(type, id, dis.readByte());
-                    break;
-                case TYPE_SHORT:
-                    di = new DataItem<>(type, id, dis.readShort());
-                    break;
-                case TYPE_INT:
-                    di = new DataItem<>(type, id, dis.readInt());
-                    break;
-                case TYPE_FLOAT:
-                    di = new DataItem<>(type, id, dis.readFloat());
-                    break;
-                case TYPE_STRING:
-                    di = new DataItem<>(type, id, Packet.readString(dis, 64));
-                    break;
-                case TYPE_ITEMSTACK:
-                    short itemId = dis.readShort();
-                    byte itemCount = dis.readByte();
-                    short itemData = dis.readShort();
-                    if (itemId == -1){
-                        di = new DataItem<>(type, id, ItemStack.NO_ITEM);
-                    } else {
+            byte metadata = dis.readByte();
+
+            DataItem<?> di = new DataItem<>(type, id, null);
+            if ((metadata & META_NULL) == 0) { // if not marked as null
+                switch(type)
+                {
+                    case TYPE_BYTE:
+                        di = new DataItem<>(type, id, dis.readByte());
+                        break;
+                    case TYPE_SHORT:
+                        di = new DataItem<>(type, id, dis.readShort());
+                        break;
+                    case TYPE_INT:
+                        di = new DataItem<>(type, id, dis.readInt());
+                        break;
+                    case TYPE_FLOAT:
+                        di = new DataItem<>(type, id, dis.readFloat());
+                        break;
+                    case TYPE_STRING:
+                        di = new DataItem<>(type, id, Packet.readString(dis, 64));
+                        break;
+                    case TYPE_ITEMSTACK:
+                        short itemId = dis.readShort();
+                        byte itemCount = dis.readByte();
+                        short itemData = dis.readShort();
                         di = new DataItem<>(type, id, new ItemStack(itemId, itemCount, itemData));
-                    }
-                    break;
-                case TYPE_CHUNK_COORDINATE:
-                    int x = dis.readInt();
-                    int y = dis.readInt();
-                    int z = dis.readInt();
-                    di = new DataItem<>(type, id, new ChunkCoordinates(x, y, z));
-                    break;
+                        break;
+                    case TYPE_CHUNK_COORDINATE:
+                        int x = dis.readInt();
+                        int y = dis.readInt();
+                        int z = dis.readInt();
+                        di = new DataItem<>(type, id, new ChunkCoordinates(x, y, z));
+                        break;
+                    case TYPE_UUID:
+                        long msb = dis.readLong();
+                        long lsb = dis.readLong();
+                        di = new DataItem<>(type, id, new UUID(msb, lsb));
+                        break;
+                }
             }
             out.add(di);
             data = dis.readByte();
@@ -328,6 +399,7 @@ public class SynchedEntityData
         DATA_TYPES.put(String.class, TYPE_STRING);
         DATA_TYPES.put(ItemStack.class, TYPE_ITEMSTACK);
         DATA_TYPES.put(ChunkCoordinates.class, TYPE_CHUNK_COORDINATE);
+        DATA_TYPES.put(UUID.class, TYPE_UUID);
     }
 
     /**
@@ -338,7 +410,7 @@ public class SynchedEntityData
     {
         private final int type;
         private final int id;
-        private T value;
+        private @Nullable T value;
         private boolean dirty;
 
         /**
@@ -347,7 +419,7 @@ public class SynchedEntityData
          * @param id The ID of the data item.
          * @param value The initial value of the data item.
          */
-        public DataItem(int type, int id, T value)
+        public DataItem(int type, int id, @Nullable T value)
         {
             this.id = id;
             this.value = value;
@@ -367,7 +439,7 @@ public class SynchedEntityData
          * Sets the value of the data item.
          * @param value The value to set.
          */
-        public void setValue(T value)
+        public void setValue(@Nullable T value)
         {
             this.value = value;
         }
@@ -375,7 +447,7 @@ public class SynchedEntityData
         /**
          * Fetches the value of the data item.
          */
-        public T getValue()
+        public @Nullable T getValue()
         {
             return this.value;
         }
diff --git a/src/main/java/net/minecraft/core/world/save/LevelData.java b/src/main/java/net/minecraft/core/world/save/LevelData.java
index d4f38340b..49f65145d 100644
--- a/src/main/java/net/minecraft/core/world/save/LevelData.java
+++ b/src/main/java/net/minecraft/core/world/save/LevelData.java
@@ -1,23 +1,39 @@
 package net.minecraft.core.world.save;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.option.enums.Difficulty;
 import net.minecraft.core.data.gamerule.GameRuleCollection;
 import net.minecraft.core.entity.player.Player;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.NbtIo;
-import net.minecraft.core.world.Dimension;
 import org.jetbrains.annotations.NotNull;
+import org.slf4j.Logger;
 
 import java.io.File;
 import java.io.IOException;
 import java.nio.file.Files;
 import java.util.List;
 
-// Referenced classes of package net.minecraft.src:
-//            NBTTagCompound, Player
-
 public class LevelData
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    private long randomSeed;
+    private int spawnX;
+    private int spawnY;
+    private int spawnZ;
+    private long worldTime;
+    private long lastTimePlayed;
+    private long sizeOnDisk;
+    private CompoundTag playerTag;
+    private int dimension;
+    private int gamemode;
+    private @NotNull String levelName = "DEFAULT NAME";
+    private int saveVersion;
+    private boolean cheatsEnabled;
+    private @NotNull Difficulty difficulty = Difficulty.NORMAL;
+    private boolean difficultyLocked;
+    private GameRuleCollection gameRules;
+
 
     public LevelData(CompoundTag tag)
     {
@@ -110,7 +126,7 @@ public class LevelData
         CompoundTag nbttagcompound = new CompoundTag();
         Player entityplayer = null;
         CompoundTag nbttagcompound1 = null;
-        if(list.size() > 0)
+        if(!list.isEmpty())
         {
             entityplayer = list.get(0);
         }
@@ -279,12 +295,12 @@ public class LevelData
     {
         return lastTimePlayed;
     }
-    
+
     public int getGamemode()
     {
     	return gamemode;
     }
-    
+
     public void setGamemode(int gamemode)
     {
     	this.gamemode = gamemode;
@@ -299,7 +315,7 @@ public class LevelData
     {
     	return cheatsEnabled;
     }
-    
+
     public void setCheatsEnabled(boolean enabled)
     {
     	this.cheatsEnabled = enabled;
@@ -312,8 +328,14 @@ public class LevelData
 
     public void setDifficulty(int difficulty, boolean overrideLock) {
         if (!overrideLock && difficultyLocked) return;
-        if (difficulty < 0) new RuntimeException("Attempted to set difficulty to '" + difficulty + "' which is less then 0!").printStackTrace();
-        if (difficulty >= Difficulty.values().length) new RuntimeException("Attempted to set difficulty to '" + difficulty + "' which is more then the '" + Difficulty.values().length + "' difficulties!").printStackTrace();
+        if (difficulty < 0) {
+            LOGGER.warn("Attempted to set difficulty to '{}' which is less then 0!", difficulty);
+            difficulty = 0;
+        }
+        if (difficulty >= Difficulty.values().length) {
+            LOGGER.error("Attempted to set difficulty to '{}' which is more then the '{}' difficulties!", difficulty, Difficulty.values().length);
+            difficulty = Difficulty.values().length - 1;
+        }
         setDifficulty(Difficulty.values()[difficulty], overrideLock);
     }
 
@@ -328,21 +350,4 @@ public class LevelData
     public boolean getDifficultyLocked() {
         return difficultyLocked;
     }
-
-    private long randomSeed;
-    private int spawnX;
-    private int spawnY;
-    private int spawnZ;
-    private long worldTime;
-    private long lastTimePlayed;
-    private long sizeOnDisk;
-    private CompoundTag playerTag;
-    private int dimension;
-    private int gamemode;
-    private @NotNull String levelName = "DEFAULT NAME";
-    private int saveVersion;
-    private boolean cheatsEnabled;
-    private @NotNull Difficulty difficulty = Difficulty.NORMAL;
-    private boolean difficultyLocked;
-    private GameRuleCollection gameRules;
 }
diff --git a/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java b/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
index f8475dbd3..bad31a653 100644
--- a/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
+++ b/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
@@ -1,14 +1,14 @@
 package net.minecraft.core.world.save;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.NbtIo;
 import net.minecraft.core.world.Dimension;
+import org.slf4j.Logger;
 
 import java.io.File;
-import java.io.FileInputStream;
-import java.io.FileOutputStream;
 import java.nio.file.Files;
 import java.util.ArrayList;
 import java.util.List;
@@ -16,6 +16,7 @@ import java.util.List;
 public abstract class SaveFormatBase
     implements ISaveFormat
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     protected final File savesDir;
 
     public SaveFormatBase(File savesDir)
@@ -54,7 +55,7 @@ public abstract class SaveFormatBase
             }
             catch(Exception ex)
             {
-                ex.printStackTrace();
+                LOGGER.error("Exception loading level dat for world '{}'!", worldDirName, ex);
             }
         }
         worldLevelDat = new File(worldDir, "level.dat_old");
@@ -68,7 +69,7 @@ public abstract class SaveFormatBase
             }
             catch(Exception ex)
             {
-                ex.printStackTrace();
+                LOGGER.error("Exception loading level dat old for world '{}'!", worldDirName, ex);
             }
         }
         return null;
@@ -103,7 +104,7 @@ public abstract class SaveFormatBase
             }
             catch (Exception ex)
             {
-                ex.printStackTrace();
+                LOGGER.error("Exception loading dimension dat '{}' for world '{}'!", dimensionId, worldDirName, ex);
             }
         }
         dimensionDat = new File(dimensionDir, "dimension.dat_old");
@@ -117,7 +118,7 @@ public abstract class SaveFormatBase
             }
             catch (Exception ex)
             {
-                ex.printStackTrace();
+                LOGGER.error("Exception loading dimension dat old '{}' for world '{}'!", dimensionId, worldDirName, ex);
             }
         }
 
@@ -186,14 +187,14 @@ public abstract class SaveFormatBase
         {
             try
             {
-                CompoundTag nbtRoot = NbtIo.readCompressed(new FileInputStream(worldLevelDat));
+                CompoundTag nbtRoot = NbtIo.readCompressed(Files.newInputStream(worldLevelDat.toPath()));
                 CompoundTag nbtRootData = nbtRoot.getCompound("Data");
                 nbtRootData.putString("LevelName", newName);
-                NbtIo.writeCompressed(nbtRoot, new FileOutputStream(worldLevelDat));
+                NbtIo.writeCompressed(nbtRoot, Files.newOutputStream(worldLevelDat.toPath()));
             }
             catch(Exception exception)
             {
-                exception.printStackTrace();
+                LOGGER.error("Failed to rename world '{}' to '{}'!", worldDirName, newName, exception);
             }
         }
     }
diff --git a/src/main/java/net/minecraft/core/world/save/SaveFormats.java b/src/main/java/net/minecraft/core/world/save/SaveFormats.java
index 6389a52b6..2c51aa4a9 100644
--- a/src/main/java/net/minecraft/core/world/save/SaveFormats.java
+++ b/src/main/java/net/minecraft/core/world/save/SaveFormats.java
@@ -1,9 +1,12 @@
 package net.minecraft.core.world.save;
 
+import com.mojang.logging.LogUtils;
+import net.minecraft.core.Global;
 import net.minecraft.core.world.save.legacy.SaveFormatLegacy;
 import net.minecraft.core.world.save.mcregion.SaveFormat19132;
 import net.minecraft.core.world.save.mcregion.SaveFormat19133;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
+import org.slf4j.Logger;
 
 import java.io.File;
 import java.util.HashMap;
@@ -11,6 +14,7 @@ import java.util.Map;
 
 public class SaveFormats
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     public static Map<Integer, Class<? extends ISaveFormat>> saveFormats;
 
     public static ISaveFormat createSaveFormat(int version, File savesDir)
@@ -23,7 +27,7 @@ public class SaveFormats
         }
         catch (Exception e)
         {
-            e.printStackTrace();
+            LOGGER.error("Exception instancing ISaveFormat from '{}'!", version, e);
             return null;
         }
     }
diff --git a/src/main/java/net/minecraft/core/world/save/SaveHandlerBase.java b/src/main/java/net/minecraft/core/world/save/SaveHandlerBase.java
index cfb4e6793..3f8b1fb82 100644
--- a/src/main/java/net/minecraft/core/world/save/SaveHandlerBase.java
+++ b/src/main/java/net/minecraft/core/world/save/SaveHandlerBase.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.world.save;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.MinecraftException;
 import net.minecraft.core.entity.player.Player;
 import com.mojang.nbt.CompoundTag;
@@ -7,18 +8,18 @@ import com.mojang.nbt.NbtIo;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.chunk.ChunkLoaderLegacy;
 import net.minecraft.core.world.chunk.IChunkLoader;
+import org.slf4j.Logger;
 
 import java.io.DataInputStream;
 import java.io.DataOutputStream;
 import java.io.File;
-import java.io.FileInputStream;
-import java.io.FileOutputStream;
 import java.io.IOException;
 import java.nio.file.Files;
 import java.util.List;
 
 public abstract class SaveHandlerBase implements LevelStorage
 {
+	private static final Logger LOGGER = LogUtils.getLogger();
 	final String worldDirName;
 	final File saveDirectory;
 	final File playersDirectory;
@@ -46,12 +47,12 @@ public abstract class SaveHandlerBase implements LevelStorage
 	{
 		try {
 			File file = new File(saveDirectory, "session.lock");
-			try (DataOutputStream stream = new DataOutputStream(new FileOutputStream(file)))
+			try (DataOutputStream stream = new DataOutputStream(Files.newOutputStream(file.toPath())))
 			{
 				stream.writeLong(now);
 			}
 		} catch (IOException ioexception) {
-			ioexception.printStackTrace();
+			LOGGER.error("Failed to check session lock!", ioexception);
 			throw new RuntimeException("Failed to check session lock, aborting");
 		}
 	}
@@ -67,7 +68,7 @@ public abstract class SaveHandlerBase implements LevelStorage
 		try
 		{
 			File file = new File(saveDirectory, "session.lock");
-			try (DataInputStream datainputstream = new DataInputStream(new FileInputStream(file)))
+			try (DataInputStream datainputstream = new DataInputStream(Files.newInputStream(file.toPath())))
 			{
 				if (datainputstream.readLong() != now)
 				{
@@ -117,15 +118,15 @@ public abstract class SaveHandlerBase implements LevelStorage
 	@Override
 	public void saveLevelDataAndPlayerData(LevelData levelData, List<Player> playerList)
 	{
-		CompoundTag nbttagcompound = levelData.getNBTTagCompoundWithPlayer(playerList);
-		CompoundTag nbttagcompound1 = new CompoundTag();
-		nbttagcompound1.put("Data", nbttagcompound);
+		CompoundTag dataTag = levelData.getNBTTagCompoundWithPlayer(playerList);
+		CompoundTag savedTag = new CompoundTag();
+		savedTag.put("Data", dataTag);
 		try
 		{
 			File file = new File(saveDirectory, "level.dat_new");
 			File file1 = new File(saveDirectory, "level.dat_old");
 			File file2 = new File(saveDirectory, "level.dat");
-			NbtIo.writeCompressed(nbttagcompound1, new FileOutputStream(file));
+			NbtIo.writeCompressed(savedTag, Files.newOutputStream(file.toPath()));
 			if (file1.exists())
 			{
 				file1.delete();
@@ -143,7 +144,7 @@ public abstract class SaveHandlerBase implements LevelStorage
 		}
 		catch (Exception exception)
 		{
-			exception.printStackTrace();
+			LOGGER.error("Failed to save level data to disk!", exception);
 		}
 	}
 
@@ -182,7 +183,7 @@ public abstract class SaveHandlerBase implements LevelStorage
 		}
 		catch (Exception exception)
 		{
-			exception.printStackTrace();
+			LOGGER.error("Failed to save level data to disk!", exception);
 		}
 
 	}
@@ -226,7 +227,7 @@ public abstract class SaveHandlerBase implements LevelStorage
 		}
 		catch (Exception exception)
 		{
-			exception.printStackTrace();
+            LOGGER.error("Failed to save dimension {} data to disk!", dimensionId, exception);
 		}
 	}
 
diff --git a/src/main/java/net/minecraft/core/world/save/SaveHandlerServer.java b/src/main/java/net/minecraft/core/world/save/SaveHandlerServer.java
index e0e4995a5..d6c68b811 100644
--- a/src/main/java/net/minecraft/core/world/save/SaveHandlerServer.java
+++ b/src/main/java/net/minecraft/core/world/save/SaveHandlerServer.java
@@ -1,25 +1,27 @@
 package net.minecraft.core.world.save;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.entity.player.Player;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import com.mojang.nbt.NbtIo;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.chunk.ChunkLoaderRegion;
-import org.apache.log4j.Logger;
+import org.slf4j.Logger;
 
 
 import java.io.File;
-import java.io.FileInputStream;
 import java.io.FileOutputStream;
+import java.nio.file.Files;
 import java.util.List;
+import java.util.UUID;
 
 
 public class SaveHandlerServer
         extends SaveHandlerBase
         implements PlayerIO
 {
-    private static final Logger logger = Logger.getLogger("Minecraft");
+    private static final Logger LOGGER = LogUtils.getLogger();
 
     public SaveHandlerServer(ISaveFormat saveFormat, File savesDir, String worldDirName, boolean isMultiplayer)
     {
@@ -49,25 +51,26 @@ public class SaveHandlerServer
         {
             CompoundTag nbttagcompound = new CompoundTag();
             player.saveWithoutId(nbttagcompound);
-            File file = new File(playersDirectory, "_tmp_.dat");
-            File file1 = new File(playersDirectory, player.username + ".dat");
-            NbtIo.writeCompressed(nbttagcompound, new FileOutputStream(file));
-            if(file1.exists())
+            nbttagcompound.putInt("Format", 1);
+            File temp = new File(playersDirectory, "_tmp_.dat");
+            File save = new File(playersDirectory, player.uuid + ".dat");
+            NbtIo.writeCompressed(nbttagcompound, new FileOutputStream(temp));
+            if(save.exists())
             {
-                file1.delete();
+                save.delete();
             }
-            file.renameTo(file1);
+            temp.renameTo(save);
         }
         catch(Exception exception)
         {
-            logger.warn("Failed to save player data for " + player.username);
+            LOGGER.warn("Failed to save player data for " + player.username);
         }
     }
 
     @Override
     public void load(Player player)
     {
-        CompoundTag nbttagcompound = getPlayerData(player.username);
+        CompoundTag nbttagcompound = getPlayerData(player.username, player.uuid);
         if(nbttagcompound != null)
         {
             player.load(nbttagcompound);
@@ -80,19 +83,26 @@ public class SaveHandlerServer
         return this;
     }
 
-    private CompoundTag getPlayerData(String s)
+    private CompoundTag getPlayerData(String username, UUID uuid)
     {
         try
         {
-            File file = new File(playersDirectory, s + ".dat");
-            if(file.exists())
+            File uuidFile = new File(playersDirectory, uuid + ".dat");
+            if(uuidFile.exists())
             {
-                return NbtIo.readCompressed(new FileInputStream(file));
+                return NbtIo.readCompressed(Files.newInputStream(uuidFile.toPath()));
+            } else { // If the uuid file doesn't exist attempt to load the old username file
+                File nameFile = new File(playersDirectory, username + ".dat");
+                if (nameFile.exists()) {
+                    CompoundTag tag = NbtIo.readCompressed(Files.newInputStream(nameFile.toPath()));
+                    nameFile.renameTo(uuidFile);
+                    return tag;
+                }
             }
         }
         catch(Exception exception)
         {
-            logger.warn("Failed to load player data for " + s);
+            LOGGER.warn("Failed to load player data for " + username);
         }
         return null;
     }
